<?php

class myPage{
	protected $count; //总条数
	protected $showPages; //需要显示的页数
	protected $countPages; //总页数
	protected $currPage; //当前页
	protected $subPages; //每页显示条数
	protected $href; //连接
	protected $page_arr=array(); //保存生成的页码 键页码 值为连接

	/**
	* __construct 构造函数（获取分页所需参数）
	* @param int $count 总条数
	* @param int $showPages 显示页数
	* @param int $currPage 当前页数
	* @param int $subPages 每页显示数量
	* @param string $href 连接（不设置则获取当前URL）
	*/
	public function __construct($count,$showPages,$currPage,$subPages,$href=''){
		$this->count=$count;
		$this->showPages=$showPages;
		$this->currPage=$currPage;
		$this->subPages=$subPages;

		//如果链接没有设置则获取当前连接
		if(empty($href)){
			$this->href=htmlentities($_SERVER['PHP_SELF']);
		}else{
			$this->href=$href;
		}

		$this->construct_Pages();
	}

	/**
	* getPages 返回页码数组
	* @return array 一维数组 键为页码 值为链接
	*/
	public function getPages(){
		return $this->page_arr;
	}

	/**
	* showPages 返回生成好的页码
	* @param int $style 样式
	* @return string 生成好的页码
	*/
	public function showPages($style=1){
		$func='pageStyle'.$style;
		return $this->$func();
	}

	/**
	* @return string
	*/
	protected function pageStyle1(){

		$pageStr='';
		$parameter=(strpos($this->href, '?')==false) ? '?':'&';

		if($this->currPage!=1){
			$pageStr='<li class="page-item"><a class="page-link" href="'.$this->href.$parameter.'p=1">首页</a></li>';
		}

		//如果当前页不是第一页就显示上页
		if($this->currPage>1){
			// $pageStr.='<li class="page-item"><a class="page-link" style="color: #ffc107;" href="/?'.$this->href.'&p='.($this->currPage-1).'">上页</a></li>';
		}

		foreach ($this->page_arr as $k => $v) {

			if($this->currPage==$k){
				$pageStr.='<li class="page-item active"><a class="page-link"  href="'.$this->href.$parameter.'p='.$k.'">'.$k.'</a></li>';
			}
			else{
				$pageStr.='<li class="page-item"><a class="page-link"  href="'.$this->href.$parameter.'p='.$k.'">'.$k.'</a></li>';
			}

			
		}

		//如果当前页小于总页数就显示下一页
		if($this->currPage<$this->countPages){
			// $pageStr.='<li class="page-item"><a class="page-link" style="color: #ffc107;" href="/?'.$this->href.'&p='.($this->currPage+1).'">下页</a></li>';
		}

		if($this->currPage!=$this->countPages){
			$pageStr.='<li class="page-item"><a class="page-link"  href="'.$this->href.$parameter.'p='.$this->countPages.'">尾页</a></li>';
		}

		if($this->href=='/'){
			$pageStr=str_replace('&','?',$pageStr);
		}

		return $pageStr;
	}

	/**
	* construct_Pages 生成页码数组
	*/
	protected function construct_Pages(){
		//计算总页数
		$this->countPages=ceil($this->count/$this->subPages);
		//根据当前页计算前后页数
		$leftPage_num=floor($this->showPages/2);
		$rightPage_num=$this->showPages-$leftPage_num;

		//左边显示数为当前页减左边该显示的数 例如总显示7页 当前页是5 左边最小为5-3 右边为5+3
		$left=$this->currPage-$leftPage_num;
		$left=max($left,1); //左边最小不能小于1
		$right=$left+$this->showPages-1; //左边加显示页数减1就是右边显示数
		$right=min($right,$this->countPages); //右边最大不能大于总页数
		$left=max($right-$this->showPages+1,1); //确定右边再计算左边，必须二次计算

		for ($i=$left; $i <= $right; $i++) {
			$_GET['p'] = $i;
			$this->page_arr[$i]=$this->href.'?'.http_build_query($_GET);
		}
	}

}


// 实例化myPage类
$count=100;
$showPages=4;
$currPage=isset($_GET['p']) ? $_GET['p']:1;
$subPages=10;
$href='';

$res=new myPage($count,$showPages,$currPage,$subPages,$href);;
$showPage=$res->showPages(1);

// 基于boostrap5 css样式
echo '<link rel="stylesheet" href="style.css">';
echo '<div class="mt-4" style="text-align:center;"><h1>content-page-'.$currPage.'</h1><p><nav aria-label="navigation"><ul class="pagination pagination-light d-inline-block d-md-flex justify-content-center">';
echo $showPage;
echo '</ul></nav></div>';

// 很多逻辑判断，因为用不到，暂时被注释，可自行修改

?>